import React from 'react';
import purebem from 'purebem';
import { mount } from 'enzyme';

import Button from './Button';


const TestButton = Button({
    block: purebem.of('test-button'),
    displayName: 'TestButton',
    Spinner: () => (<div />)
});

test('should trigger click event when clicked', () => {
    const onClick = jest.fn();
    const button = mount(
        <TestButton
            onClick={ onClick } />
    );

    button.simulate('click');

    expect(onClick).toHaveBeenCalled();
});

test('should not trigger click event when clicked and disabled', () => {
    const onClick = jest.fn();
    const button = mount(
        <TestButton
            disabled={ true }
            onClick={ onClick } />
    );

    button.simulate('click');

    expect(onClick).not.toHaveBeenCalled();
});
