import React from 'react';
import purebem from 'purebem';
import { mount } from 'enzyme';

import simulateLabelClick from '../../test-utils/simulateLabelClick';

import Checkbox from './Checkbox';
import CheckboxState from './CheckboxState';


const TestCheckbox = Checkbox({
    block: purebem.of('test-checkbox'),
    displayName: 'TestCheckbox'
});

const TestCheckboxState = CheckboxState({
    Component: TestCheckbox
});

test('should set value', () => {
    const initialValue = true;
    const checkbox = mount(
        <TestCheckboxState
            initialValue={ initialValue } />
    );

    expect(checkbox.state('value')).toBe(initialValue);
});

test('should change value when clicked', () => {
    const onChange = jest.fn();
    const checkbox = mount(
        <TestCheckboxState
            initialValue={ false }
            onChange={ onChange } />
    );

    simulateLabelClick(checkbox);

    expect(onChange).toHaveBeenCalledWith(true);
});
