import React from 'react';
import purebem from 'purebem';
import { mount } from 'enzyme';

import Switch from './Switch';
import SwitchState from './SwitchState';


const TestSwitch = Switch({
    block: purebem.of('test-Switch'),
    displayName: 'TestSwitch'
});

const TestSwitchState = SwitchState({
    Component: TestSwitch
});

test('should set value', () => {
    const initialValue = true;
    const checkbox = mount(
        <TestSwitchState
            initialValue={ initialValue } />
    );

    expect(checkbox.state('value')).toBe(initialValue);
});

test('should change value when clicked', () => {
    const onChange = jest.fn();

    const checkbox = mount(
        <TestSwitchState
            initialValue={ false }
            onChange={ onChange } />
    );

    checkbox.find('TestSwitchLever').simulate('click');

    expect(onChange).toHaveBeenCalledWith(true);
});
