import createDynamicReducerRegistry from './createDynamicReducerRegistry';


test('add', () => {
    const registry = createDynamicReducerRegistry();
    registry.add('test', {
        'TEST-ACTION': (state) => state
    });

    const reducers = registry.getReducers();
    expect(reducers.length).toBe(1);
    expect(typeof reducers[0] === 'function').toBe(true);
});

test('remove', () => {
    const registry = createDynamicReducerRegistry();
    registry.add('test', {
        'TEST-ACTION': (state) => state
    });

    registry.remove('test');

    const reducers = registry.getReducers();
    expect(reducers.length).toBe(0);
});
