import { handleActions } from 'redux-seamless-reducers';
import invariant from 'invariant';
import isPlainObject from 'lodash.isplainobject';


export default () => {
    const registry = new Map();
    return {
        add: (name, actionObject) => {
            invariant(isPlainObject(actionObject), 'Expected `actionObject` to be an object.');

            registry.set(name, handleActions(actionObject));
        },
        getReducers: () => {
            return Array.from(registry.values());
        },
        remove: (name) => {
            registry.delete(name);
        }
    };
};
