import Immutable from 'seamless-immutable';

import mount, { reducer, type } from './mount';


test('should mount state if undefined', () => {
    const root = 'test';

    const action = mount({ initialComponentState: { my: 'state' }, root });
    const state = reducer[type](Immutable({ meta: { mounted: {} } }), action);

    expect(state).toEqual({ [root]: { my: 'state' }, meta: { mounted: { [root]: true } } });
});

test('should mount state if defined but not marked as mounted', () => {
    const root = 'test';

    const action = mount({ initialComponentState: { my: 'state' }, root });
    const state = reducer[type](Immutable({ [root]: { my: 'unmounted state' }, meta: { mounted: {} } }), action);

    expect(state).toEqual({ [root]: { my: 'state' }, meta: { mounted: { [root]: true } } });
});

test('should not re-mount state', () => {
    const root = 'test';

    const action = mount({ initialComponentState: { my: 'state' }, root });
    const state = reducer[type](Immutable({ meta: { mounted: {} } }), action);

    const raction = mount({ initialComponentState: { my: 'new state' }, root });
    const rstate = reducer[type](state, raction);

    expect(rstate).toEqual({ [root]: { my: 'state' }, meta: { mounted: { [root]: true } } });
});
