export const type = 'BILLOGRAM-FOUNDATION.COMPONENT-UNMOUNT';

export default ({ root }) => {
    return {
        type,
        meta: {
            root
        }
    };
};

export const reducer = {
    [type]: (state, action) => {
        const { root } = action.meta;
        const { [root]: omit, ...others } = state.meta.mounted;     // eslint-disable-line no-unused-vars

        return state
            .without(root)
            .setIn(['meta', 'mounted'], others);
    }
};
