import React from 'react';
import purebem from 'purebem';
import { mount } from 'enzyme';

import Datepicker from './Datepicker';
import DatepickerState from './DatepickerState';


const TestDatepicker = Datepicker({
    block: purebem.of('test-datepicker'),
    displayName: 'TestDatepicker'
});

const TestDatepickerState = DatepickerState({
    Component: TestDatepicker
});

test('should expand when clicked and collapsed', () => {
    const datepicker = mount(
        <TestDatepickerState />
    );

    datepicker.find('TestDatepickerControl').simulate('click');

    expect(datepicker.state('expanded')).toBe(true);
});

test('should collapse when clicked and expanded', () => {
    const datepicker = mount(
        <TestDatepickerState />
    );

    datepicker.setState({ expanded: true });
    datepicker.find('TestDatepickerControl').simulate('click');

    expect(datepicker.state('expanded')).toBe(false);
});
