import { PropTypes } from 'react';
import intersection from 'lodash.intersection';
import purebem from 'purebem';

import Datepicker from './Datepicker';

import './FoundationDatepicker.less';


const uiColorModifiers = [
    'gray', 'default',
    'transparent'
];

const uiModifiers = PropTypes.oneOf([
    ...uiColorModifiers,
    'stretched'
]);

const defaultUIColorModifier = 'default';

export default Datepicker({
    block: purebem.of('foundation-new-datepicker'),
    displayName: 'FoundationDatepicker',
    uiPropDefaultType: PropTypes.oneOfType([
        uiModifiers,
        PropTypes.arrayOf(uiModifiers)
    ]),
    uiPropDefaultValue: defaultUIColorModifier,
    uiPropGetValue: (ui) => {
        const uiArray = typeof ui === 'string' ? [ui] : ui;
        const hasUIColorModifier = intersection(uiArray, uiColorModifiers).length > 0;

        return hasUIColorModifier ? uiArray : [defaultUIColorModifier, ...uiArray];
    }
});
