import datepickerState from './datepickerState';


test('null and collapsed as default', () => {
    const result = datepickerState();

    expect(result.expanded).toBe(false);
    expect(result.value).toBe(null);
});

test('value as selected index', () => {
    const value = +new Date(2000, 0, 31);
    const result = datepickerState({ value });

    expect(result.selectedIndex).toBe(value);
    expect(result.value).toBe(value);
});

test('start of month as current month of value', () => {
    const value = +new Date(2000, 0, 31);
    const result = datepickerState({ value });

    expect(result.currentMonth).toBe(+new Date(2000, 0, 1));
});

test('empty string is null', () => {
    const result = datepickerState({ value: '' });

    expect(result.value).toBe(null);
});
