import { PropTypes } from 'react';
import intersection from 'lodash.intersection';
import purebem from 'purebem';

import Dropdown from './Dropdown';

import './FoundationDropdown.less';


const uiColorModifiers = [
    'gray', 'default',
    'teal', 'primary',
    'route'
];

const uiModifiers = PropTypes.oneOf([
    ...uiColorModifiers,
    'mobile-stretched',
    'mobile-tablet-stretched',
    'stretched'
]);

const defaultUIColorModifier = 'default';

export default Dropdown({
    block: purebem.of('foundation-new-dropdown'),
    displayName: 'FoundationDropdown',
    uiPropDefaultType: PropTypes.oneOfType([
        uiModifiers,
        PropTypes.arrayOf(uiModifiers)
    ]),
    uiPropDefaultValue: defaultUIColorModifier,
    uiPropGetValue: (ui) => {
        const uiArray = typeof ui === 'string' ? [ui] : ui;
        const hasUIColorModifier = intersection(uiArray, uiColorModifiers).length > 0;

        return hasUIColorModifier ? uiArray : [defaultUIColorModifier, ...uiArray];
    }
});
