import React from 'react';
import purebem from 'purebem';
import { mount } from 'enzyme';

import DropdownActionOption from './DropdownActionOption';


const TestDropdownActionOption = DropdownActionOption({
    block: purebem.of('test-dropdown'),
    displayName: 'TestDropdownActionOption'
});

test('should perform action when clicked', () => {
    const onClick = jest.fn();
    const option = mount(
        <TestDropdownActionOption
            onClick={ onClick }
            value="test" />
    );

    option.simulate('click');

    expect(onClick).toHaveBeenCalledWith('test');
});

test('should not perform action when clicked and disabled', () => {
    const handler = jest.fn();
    const option = mount(
        <TestDropdownActionOption
            disabled={ true }
            onClick={ handler }
            value="test" />
    );

    option.simulate('click');

    expect(handler).not.toHaveBeenCalled();
});
