import React, { PropTypes } from 'react';
import PureRenderMixin from 'react-addons-pure-render-mixin';


export default ({
    block,
    displayName
} = {}) => {

    return React.createClass({

        displayName,

        mixins: [PureRenderMixin],

        propTypes: {
            disabled: PropTypes.bool,
            highlighted: PropTypes.bool,
            onClick: PropTypes.func,
            text: PropTypes.string,
            value: PropTypes.any
        },

        getDefaultProps() {
            return {
                disabled: false,
                highlighted: false,
                onClick: (/* value */) => {},
                text: '',
                value: ''
            };
        },

        onClick() {
            const { disabled, onClick, value } = this.props;
            if (disabled) {
                return;
            }

            onClick(value);
        },

        render() {
            const { disabled, highlighted, text } = this.props;
            return (
                <div
                    className={ block('option', { disabled, highlighted }) }
                    onClick={ this.onClick }>
                    { text }
                </div>
            );
        }

    });

};
