import React, { PropTypes } from 'react';
import PureRenderMixin from 'react-addons-pure-render-mixin';
import purebem from 'purebem';

import './FoundationFormContentSection.less';


const block = purebem.of('foundation-new-form-content-section');

const FoundationFormContentSection = React.createClass({

    mixins: [PureRenderMixin],

    propTypes: {
        children: PropTypes.node,
        row: PropTypes.bool
    },

    getDefaultProps() {
        return {
            children: null,
            row: false
        };
    },

    render() {
        const { children, row } = this.props;
        return (
            <div className={ block({ column: !row, row }) }>
                { children }
            </div>
        );
    }

});

export default FoundationFormContentSection;
