import React, { PropTypes } from 'react';
import PureRenderMixin from 'react-addons-pure-render-mixin';
import purebem from 'purebem';

import './FoundationFormControlSection.less';


const block = purebem.of('foundation-new-form-control-section');

const FoundationFormControlSection = React.createClass({

    mixins: [PureRenderMixin],

    propTypes: {
        children: PropTypes.node,
        row: PropTypes.bool,
        size: PropTypes.oneOf(['default', 'narrow'])
    },

    getDefaultProps() {
        return {
            children: null,
            row: false,
            size: 'default'
        };
    },

    render() {
        const { children, row, size } = this.props;
        return (
            <div className={ block({ column: !row, row, size }) }>
                { children }
            </div>
        );
    }

});

export default FoundationFormControlSection;
