import React, { PropTypes } from 'react';
import PureRenderMixin from 'react-addons-pure-render-mixin';
import purebem from 'purebem';

import './FoundationFormTitleSection.less';


const block = purebem.of('foundation-new-form-title-section');

const FoundationFormTitleSection = React.createClass({

    mixins: [PureRenderMixin],

    propTypes: {
        children: PropTypes.node,
        text: PropTypes.string
    },

    getDefaultProps() {
        return {
            children: null,
            text: null
        };
    },

    renderTitle() {
        if (this.props.text === null) {
            return null;
        }

        return (
            <div>
                <div className={ block('title') }>
                    { this.props.text }
                </div>
                <hr className={ block('separator', ['top']) } />
            </div>
        );
    },

    render() {
        return (
            <div className={ block() }>
                { this.renderTitle() }
                <div className={ block('content') }>
                    { this.props.children }
                </div>
                <hr className={ block('separator', ['bottom']) } />
            </div>
        );
    }

});

export default FoundationFormTitleSection;
