import React, { PropTypes } from 'react';
import PureRenderMixin from 'react-addons-pure-render-mixin';
import invariant from 'invariant';

import isNullOrEmpty from '../../utils/isNullOrEmpty';


export default ({
    block,
    displayName
}) => {

    invariant(block !== undefined, 'Missing purebem block');
    invariant(!isNullOrEmpty(displayName), 'Missing display name.');

    return React.createClass({

        displayName,

        mixins: [PureRenderMixin],

        propTypes: {
            description: PropTypes.node,
            html: PropTypes.bool
        },

        getDefaultProps() {
            return {
                description: '&nbsp;',
                html: false
            };
        },

        render() {
            const { description, html } = this.props;

            return html
                ? (<div className={ block() } dangerouslySetInnerHTML={ { __html: description } } />)
                : (<div className={ block() }>{ description }</div>);
        }

    });

};
