import React, { PropTypes } from 'react';
import PureRenderMixin from 'react-addons-pure-render-mixin';
import invariant from 'invariant';


export default ({
    Component
} = {}) => {

    invariant(Component !== undefined, 'Missing RadioButtonGroup componnent');

    return React.createClass({

        displayName: `${Component.displayName}State`,

        mixins: [PureRenderMixin],

        propTypes: {
            initialValue: PropTypes.string,
            onChange: PropTypes.func
        },

        getDefaultProps() {
            return {
                initialValue: '',
                onChange: (/* value */) => {}
            };
        },

        getInitialState() {
            const { initialValue: value } = this.props;
            return {
                value
            };
        },

        onChange(value) {
            this.setState({ value }, () => this.props.onChange(value));
        },

        render() {
            return (
                <Component
                    { ...this.props }
                    { ...this.state }
                    onChange={ this.onChange } />
            );
        }

    });

};
