import textboxNumberState from './textboxNumberState';


test('should have sensible defaults', () => {
    const state = textboxNumberState();
    expect(state).toEqual({ focus: false, rawValue: '', value: 0 });
});

test('should set rawValue when setting value', () => {
    const state = textboxNumberState({ value: 1 });
    expect(state).toEqual({ focus: false, rawValue: '1', value: 1 });
});

test('should not be able to set non-numeric value', () => {
    const state = textboxNumberState({ value: 'a' });
    expect(state).toEqual({ focus: false, rawValue: '', value: 0 });
});

test('should convert numeric string value to number', () => {
    const state = textboxNumberState({ value: '1' });
    expect(state).toEqual({ focus: false, rawValue: '1', value: 1 });
});
