const isInvalidNumber = (maxNumberOfDots) => (inp) => (inp.match(/\./g) || []).length > maxNumberOfDots;

const isInvalidFloat = isInvalidNumber(1);
const isInvalidInteger = isInvalidNumber(0);

const isInvalidType = (replacedInput, type) => {
    switch (type) {
        case 'float':
            return isInvalidFloat(replacedInput);

        case 'integer':
            return isInvalidInteger(replacedInput);

        default:
            return true;
    }
};

export default (input, type) => {
    if (input.length === 1 && input.startsWith('-')) {
        return { value: 0, valid: true };
    }

    const replacedInput = input.replace(',', '.');
    const value = Number(replacedInput);

    if (Number.isNaN(value) || isInvalidType(replacedInput, type)) {
        return { value: '', valid: false };
    }

    return { value, valid: true };
};
