import Immutable from 'seamless-immutable';
import { applyMiddleware, combineReducers, createStore } from 'redux';
import thunk from 'redux-thunk';

import {
    componentsReducerProvider,
    messagesReducerProvider
} from '../../modules';


export default (defaultComponentState = {}) => {
    const root = combineReducers({
        actions: (state = Immutable([]), action = {}) => {
            if (action.type === '@@redux/INIT') {
                return state;
            }

            return [...state, action];
        },
        ...componentsReducerProvider({ defaultState: defaultComponentState }),
        ...messagesReducerProvider()
    });

    return createStore(
        (state, action) => {
            return Immutable(root(state, action));
        },
        Immutable({}),
        applyMiddleware(
            thunk
        )
    );
};
