import getComponentState from './getComponentState';


test('can get valid state', () => {
    const root = 'root';
    const path = 'path';

    const components = {
        [root]: {
            [path]: { value: 'test' }
        }
    };

    const state = getComponentState({ components }, { root, path });
    expect(state).toEqual({ value: 'test' });
});

test('throw if undefined', () => {
    const root = 'root';
    const path = 'path';

    expect(() => {
        getComponentState({ components: {} }, { root, path });
    }).toThrow();
});
