import getSeamlessPath from './getSeamlessPath';


test('single root/path', () => {
    const result = getSeamlessPath('root', 'path');
    expect(result).toEqual(['root', 'path']);
});

test('no root/path', () => {
    const result = getSeamlessPath();
    // perhaps there should be an error in stead of an empty array.
    expect(result).toEqual([]);
});

test('no path', () => {
    const result = getSeamlessPath('root');
    expect(result).toEqual(['root']);
});

test('dotted path', () => {
    const result = getSeamlessPath('root', 'path.to');
    expect(result).toEqual(['root', 'path', 'to']);
});

test('dotted root', () => {
    const result = getSeamlessPath('root.to', 'path');
    expect(result).toEqual(['root', 'to', 'path']);
});

test('indexed path', () => {
    const result = getSeamlessPath('root', 'path[0]');
    expect(result).toEqual(['root', 'path', '0']);
});

test('legacy indexed path', () => {
    const result = getSeamlessPath('root', 'path.[0]');
    expect(result).toEqual(['root', 'path', '0']);
});

test('indexed root', () => {
    const result = getSeamlessPath('root[0]', 'path');
    expect(result).toEqual(['root', '0', 'path']);
});

test('legacy indexed root', () => {
    const result = getSeamlessPath('root.[0]', 'path');
    expect(result).toEqual(['root', '0', 'path']);
});
