import React from 'react';


const getFormatSeparatedChildren = (fmt, obj) => {
    return fmt.split(/\%\((.+?)\)s|%%/).reduce(function(ref, match, index) {
        let child;

        if (index % 2 === 0) {
            if (match.length === 0) {
                return ref;
            }
            child = match;
        } else if (typeof match === 'undefined') {
            child = '%';
        } else {
            if (!(match in obj)) {
                child = '';
            } else if (typeof obj[match] !== 'string' && typeof obj[match] !== 'object') {
                child = String(obj[match]);
            } else {
                child = obj[match];
            }
        }

        ref.push(child);
        return ref;
    }, []);
};

export default (fmt, obj) => {
    const children = getFormatSeparatedChildren(fmt, obj);

    return React.createElement('span', null, ...children.map((child) => {
        if (typeof child === 'string') {
            return <span dangerouslySetInnerHTML={ { __html: child } }></span>;
        }

        return child;
    })
    );
};
